//+------------------------------------------------------------------+
//|                                               Parabolic best.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                      Copyright  2008,  .. aka lukas1.  |
//|  ...?   , ""  
//+------------------------------------------------------------------+
//   . aka lukas1.
//   .  aka lukas1.
#property copyright "Copyright  2008, MetaQuotes + lukas1"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Orange
//#property indicator_width3 1
//---- input parameters
extern double    Step=0.002;
extern int Diff=20; //      
extern int ilimit =144; 
extern int timeFrame = 0;

//---- buffers
double SarBuffer[];
//----
int    save_lastreverse;
bool   save_dirlong;
double save_start;
double save_last_high;
double save_last_low;
double save_ep;
double save_sar;
double save_delta;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorDigits(Digits+1);
//----
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,SarBuffer);
   timeFrame = MathMax(timeFrame,Period());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|  -             
//+------------------------------------------------------------------+
void SaveLastReverse(int last,int dir,double start,double low,double high,double ep,double sar)
  {
   save_lastreverse=last;
   save_dirlong=dir;
   save_start=start;
   save_last_low=low;
   save_last_high=high;
   save_ep=ep;
   save_sar=sar;
  }
//+------------------------------------------------------------------+
//| Parabolic Sell And Reverse system                                |
//+------------------------------------------------------------------+
int start()
{
   int    i,counted_bars=IndicatorCounted();
   if (timeFrame!=Period())
   {
      string name = WindowExpertName();
         for (i=Bars-2; i>=0; i--) SarBuffer[i] = iCustom(NULL,timeFrame,name,Step,Diff,ilimit,0,iBarShift(NULL,timeFrame,Time[i]));
         return(0);
   }
   static bool first=false;
   bool   dirlong;
   double start,last_high,last_low;
   double ep,sar,price_low,price_high,price;
      int limit=ilimit;
//      SetIndexDrawBegin(0,Bars-limit); 
//      SetIndexDrawBegin(1,Bars-limit); 
//----
   if(Bars<3) return(0);
   dirlong=true;
   start=Step;
//--------------------------------------------+
   i=Bars-2;
   while(i>=0)
     {
      price_low=Low[i];
      price_high=High[i];
      price=SarBuffer[i+1];//   SarBuffer  
      //sar         
      //(    SarBuffer  )
      sar=price+start*(ep-price);
//----
      if(dirlong)
        {
         start+=Step;
         if(sar>price_low)
           {
            SaveLastReverse(i,true,start,price_low,last_high,ep,sar);
            start=Step; 
            dirlong=false; 
            ep=price_low;
            last_low=price_low;
            SarBuffer[i]=last_high-Diff*Point;
            if (SarBuffer[i]<High[i]&&SarBuffer[i]>=Low[i]) 
                SarBuffer[i]=High[i]+Point;
            if (SarBuffer[i]<Low[i]) SarBuffer[i]=Low[i]-Point;
            i--;
            continue;
           }
         if(ep<price_high) { last_high=price_high; ep=price_high; }
        }
//----
      else
        {
         start+=Step;
         if(sar<price_high)
           {
            SaveLastReverse(i,false,start,last_low,price_high,ep,sar);
            start=Step; 
            dirlong=true; 
            ep=price_high;
            last_high=price_high;
            SarBuffer[i]=last_low+Diff*Point;
            if (SarBuffer[i]>Low[i]&&SarBuffer[i]<=High[i]) 
                SarBuffer[i]=Low[i]-Point;
            if (SarBuffer[i]>High[i]) SarBuffer[i]=High[i]+Point;
            i--;
            continue;
           }
         if(ep>price_low) { last_low=price_low; ep=price_low; }
        }
      SarBuffer[i]=sar;
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+